;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; coordinate system (roughly)
;; ---------------------------
;;
;;          -12
;;     .-----------.
;;     |           |
;;     |           |
;; -18 |           | +18
;;     |           |
;;     |           |
;;     `-----------'
;;          +12
;;
;;
;; script commands
;; ---------------
;; +sc_wait ticks
;; +sc_goto label
;; +sc_streaker xpos
;; +sc_buzzer xpos
;; +sc_seeker xpos
;; +sc_sweeper_left ypos
;; +sc_sweeper_right ypos
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
level_script	!zone

		;;;;;;;; wave #1 ;;;;;;;;

level_start	!for i,17 {
		+sc_streaker i*2-19
		+sc_wait 5
		}

		!for i,18 {
		+sc_streaker 19-i*2
		+sc_wait 5
		}

		+sc_wait 64


		;;;;;;;; wave #2 ;;;;;;;;

		+sc_sweeper_right -12
		+sc_streaker -15.0
		+sc_streaker -10.0 : +sc_wait 8
		+sc_streaker -12.5
		+sc_wait 136

		+sc_sweeper_left -9
		+sc_streaker 15.0
		+sc_streaker 10.0 : +sc_wait 8
		+sc_streaker 12.5
		+sc_wait 136

		+sc_sweeper_right -6
		+sc_streaker -15.0
		+sc_streaker -10.0 : +sc_wait 8
		+sc_streaker -12.5
		+sc_wait 136

		+sc_sweeper_left -3
		+sc_streaker 15.0
		+sc_streaker 10.0 : +sc_wait 8
		+sc_streaker 12.5
		+sc_wait 136


		;;;;;;;; wave #3 ;;;;;;;;

		!for i,0,9 {
		+sc_wait 14
		+sc_buzzer i*1.5-16
		+sc_wait 14
		+sc_buzzer 16-i*1.5
		}

		+sc_wait 64


		;;;;;;;; wave #4 ;;;;;;;;

		!for i,2 {
.delay		= 12

		+sc_seeker -17 : +sc_wait .delay
		+sc_seeker   0 : +sc_wait .delay
		+sc_seeker  17 : +sc_wait .delay

		+sc_seeker -15 : +sc_wait .delay
		+sc_seeker  -1 : +sc_wait .delay
		+sc_seeker  15 : +sc_wait .delay

		+sc_seeker -13 : +sc_wait .delay
		+sc_seeker   1 : +sc_wait .delay
		+sc_seeker  13 : +sc_wait .delay
		}

		+sc_wait 64


		;;;;;;;; wave #5 ;;;;;;;;

		!for i,4 {
		+sc_buzzer 0
		+sc_wait 21
		}

		!for i,4 {
		+sc_buzzer 0
		+sc_streaker -12
		+sc_streaker 12
		+sc_wait 21
		}

		!for i,4 {
		+sc_streaker -12
		+sc_streaker 12
		+sc_wait 21
		}

		+sc_wait 96

		+sc_goto level_script