a_buzzer_origin	= actor_user1
a_buzzer_phase	= actor_user2
a_buzzer_shield	= actor_user3
a_buzzer_flash	= actor_user4


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
a_scripted_buzzer !zone
		+actor_spawn .failure

		lda #a_buzzer_class
		sta actor_class,x

		lda #34
		sta actor_ypos,x

		lda #spr_buzzer
		sta actor_pattern,x

		lda #-1
		sta actor_collision,x

		lda #0
		sta a_buzzer_phase,x

		lda (script),y
		iny
		sta a_buzzer_origin,x

		lda #3-1
		sta a_buzzer_shield,x
		lda #0
		sta a_buzzer_flash,x

		+nop8
.failure	iny
		+jmp ~script_continue_cb


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
a_buzzer_update	!zone
		ldy actor_collision,x	;; collision detection
		bmi .no_collision

		lda #-1
		sta actor_collision,x
		lda #.flash_length-1
		sta a_buzzer_flash,x

		lda a_player_owner,y
		tay
		lda #player_score_low
		jsr player_award_collision_score

		dec a_buzzer_shield,x
		bpl .no_collision

		lda #player_score_high
		jsr player_award_collision_score

		+jmp ~a_explosion_replace_cb

		;;;;;;;;

.no_collision	ldy a_buzzer_flash,x
		beq .zero
		dec a_buzzer_flash,x
.zero		lda .flash_color,y
		sta actor_attrib,x

		lda a_buzzer_phase,x
		clc
		adc #2
		sta a_buzzer_phase,x
		bcc .dont_fire

		jsr a_directional_bullet_fire_at_player

	;;	+a_vertical_bullet_spawn 2,.dont_fire

.dont_fire	ldy a_buzzer_phase,x
		lda math_cos,y
		eor #$80
		lsr
		lsr
		lsr
		lsr
		lsr

		ror actor_attrib,x

		adc a_buzzer_origin,x

	;;	sbc #$20
		sta actor_xpos,x

		inc actor_ypos,x
	;;	inc actor_ypos,x
		+jmp ~actor_update_continue_cb

.flash_color	!byte vicclr_red*2
		!byte vicclr_orange*2
		!byte vicclr_lred*2
		!byte vicclr_yellow*2
		!byte vicclr_white*2
.flash_length	= *-.flash_color