a_directional_bullet_xpos_lo = actor_user1
a_directional_bullet_ypos_lo = actor_user2
a_directional_bullet_xvel_lo = actor_user3
a_directional_bullet_xvel_hi = actor_user4
a_directional_bullet_yvel_lo = actor_user5
a_directional_bullet_yvel_hi = actor_user6

a_directional_bullet_xmin = 9
a_directional_bullet_xmax = 164


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; fire a bullet towards a player
;; preserves x
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
a_directional_bullet_fire_at_player !zone
		jsr a_player_target
		bne .failure

		jsr math_atan2
		tay

		;; fallthrough


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; launch an enemy bullet at a specific angle
;; x = owner, y = angle
;; preserves x
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
a_directional_bullet_spawn
		lda math_cos,y
		sta r0
		lda math_sin,y
		sta r1

		+actor_spawn_at .failure

		;; actually spawn the bullet
		lda #a_directional_bullet_class
		sta actor_class,y

		lda actor_xpos,x
		sta actor_xpos,y
		lda actor_ypos,x
		sta actor_ypos,y

		lda #spr_enemy_bullet
		sta actor_pattern,y

		lda #-1
		sta actor_collision,y

		;; set velocity
		lda r0			;; xvel = cos(x) * 2
		asl
		sta a_directional_bullet_xvel_lo,y

		lda #$ff
		adc #$00
		eor #$ff

		sta a_directional_bullet_xvel_hi,y

		lda r1			;; yvel = sin(x) * 4
		eor #$ff
		asl
		rol
		sta a_directional_bullet_yvel_lo,y

		and #%00000001
		beq *+4
		lda #%11111111
		rol

		sta a_directional_bullet_yvel_hi,y

.failure	rts


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
a_directional_bullet_update !zone
		lda actor_collision,x
		+bpl ~actor_update_die_cb

		lda a_directional_bullet_xvel_lo,x
		adc a_directional_bullet_xpos_lo,x
		sta a_directional_bullet_xpos_lo,x

		and #$80
		ora #vicclr_lblue
		sta actor_attrib,x

		lda a_directional_bullet_xvel_hi,x
		adc actor_xpos,x
		sta actor_xpos,x

		sbc #a_directional_bullet_xmin+1
		cmp #a_directional_bullet_xmax-a_directional_bullet_xmin
		+bcs ~actor_update_die_cb

		lda a_directional_bullet_yvel_lo,x
		adc a_directional_bullet_ypos_lo,x
		sta a_directional_bullet_ypos_lo,x

		lda a_directional_bullet_yvel_hi,x
		adc actor_ypos,x
		sta actor_ypos,x
		+jmp ~actor_update_continue_cb
