a_sweeper_xmin	= 5
a_sweeper_xmax	= 167

a_sweeper_xvel	= actor_user1
a_sweeper_reload = actor_user2
a_sweeper_shield = actor_user3
a_sweeper_flash	= actor_user4


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
a_scripted_sweeper !zone
		+actor_spawn .failure

		lda #a_sweeper_class
		sta actor_class,x

		lda (script),y
		iny
		asl
		sta actor_ypos,x

		bcs .right_to_left
		lda #a_sweeper_xmin
		sta actor_xpos,x
		lda #1
		bne .continue		;; bra
.right_to_left	lda #a_sweeper_xmax
		sta actor_xpos,x
		lda #-1
.continue	sta a_sweeper_xvel,x

		lda #spr_sweeper
		sta actor_pattern,x

		lda #-1
		sta actor_collision,x

		lda #0
		sta a_sweeper_reload,x
		sta a_sweeper_flash,x

		lda #5
		sta a_sweeper_shield,x

		+nop8
.failure	iny
		+jmp ~script_continue_cb


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
a_sweeper_update !zone
		ldy actor_collision,x	;; collision detection
		bmi .no_collision

		lda #-1
		sta actor_collision,x

		lda a_player_owner,y
		tay
		lda #player_score_medium
		jsr player_award_collision_score

		dec a_sweeper_shield,x
		+beq ~a_explosion_replace_cb

		lda #%100
		sta a_sweeper_flash,x

.no_collision	ldy game_frame_odd
		bne .dont_advance
		inc actor_ypos,x

.dont_advance	lda .color,y
		lsr a_sweeper_flash,x
		beq .not_flashing
		lda #vicclr_white
.not_flashing	sta actor_attrib,x

		lda a_sweeper_xvel,x
		clc
		adc actor_xpos,x
		sta actor_xpos,x

		sbc #a_sweeper_xmin
		cmp #a_sweeper_xmax-a_sweeper_xmin
		+bcs ~actor_update_die_cb

		lda #16
		adc a_sweeper_reload,x
		sta a_sweeper_reload,x
		bcc .dont_fire

		+a_vertical_bullet_spawn 2,.dont_fire

.dont_fire	+jmp ~actor_update_continue_cb

.color		!byte vicclr_lgreen,vicclr_yellow