;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c_class_none		= %00000000
c_class_player		= %00000001
c_class_player_bullet	= %00000010
c_class_enemy		= %00000100
c_class_enemy_bullet	= %00001000

		!zone
		+align

c_class		= *+0
c_mask		= *+1

		!initmem c_class_none
.end		= *+a_sentinel_class+1

		*= c_class+a_player_class
		!byte c_class_player,c_class_enemy+c_class_enemy_bullet

		*= c_class+a_player_bullet_class
		!byte c_class_player_bullet,c_class_enemy

		*= c_class+a_player_laser_class
		!byte c_class_player_bullet,c_class_enemy

		*= c_class+a_buzzer_class
		!byte c_class_enemy,c_class_player+c_class_player_bullet

		*= c_class+a_streaker_class
		!byte c_class_enemy,c_class_player+c_class_player_bullet

		*= c_class+a_seeker_class
		!byte c_class_enemy,c_class_player+c_class_player_bullet

		*= c_class+a_sweeper_class
		!byte c_class_enemy,c_class_player+c_class_player_bullet

		*= c_class+a_vertical_bullet_class
		!byte c_class_enemy_bullet,c_class_player

		*= c_class+a_directional_bullet_class
		!byte c_class_enemy_bullet,c_class_player

		*= .end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; save a copy of the collision bitmaps so they don't get overwritten if we
;; run out of vblank time
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
collision_cache_masks !zone
		lda actor_count
		sta collision_count

mux_cmask	= *+1
mux_cmask_pitch	= 5

		lda #$ff : sta collision_mask8
		lda #$ff : sta collision_mask9
		lda #$ff : sta collision_mask10
		lda #$ff : sta collision_mask11
		lda #$ff : sta collision_mask12
		lda #$ff : sta collision_mask13
		lda #$ff : sta collision_mask14
		lda #$ff : sta collision_mask15
		lda #$ff : sta collision_mask16
		lda #$ff : sta collision_mask17
		lda #$ff : sta collision_mask18
		lda #$ff : sta collision_mask19
		lda #$ff : sta collision_mask20
		lda #$ff : sta collision_mask21
		lda #$ff : sta collision_mask22
		lda #$ff : sta collision_mask23
		lda #$ff : sta collision_mask24
		lda #$ff : sta collision_mask25
		lda #$ff : sta collision_mask26
		lda #$ff : sta collision_mask27
		lda #$ff : sta collision_mask28
		lda #$ff : sta collision_mask29
		lda #$ff : sta collision_mask30
		lda #$ff : sta collision_mask31
		lda #$ff : sta collision_mask32
		rts


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		;; zeropage assignments during collision detection
collision_return = r0		;; 2 bytes
collision_outer_mask = r2
collision_inner_mask = r3
collision_outer_actor = r4
collision_outer_c_class = r5
collision_stack = r6
collision_window = r7		;; 8 bytes

collision_detection !zone
		;; fetch the initial block of actor indices
		!for i,0,8 {
		lda actor_order_stack-i
		sta collision_window+i
		}

		;; patch the code ahead so that we don't process any more
		;; collision bytes than we've got
		+ldx_imm ~collision_count,0
		lda .return_lo,x
		sta r0
		lda .return_hi,x
		sta r1

		ldy #0			;; set rts opcode
		lda #$60
		sta (collision_return),y

		jsr .start		;; begin the actual detection

		ldy #0			;; restore lda #$?? opcode
		lda #$a9
		sta (collision_return),y
		rts

.return_lo	!byte <.8
		!byte <.9,<.9,<.9,<.9
		!byte <.9,<.9,<.9,<.9
		!byte <.10,<.11,<.12,<.13
		!byte <.14,<.15,<.16,<.17
		!byte <.18,<.19,<.20,<.21
		!byte <.22,<.23,<.24,<.25
		!byte <.26,<.27,<.28,<.29
		!byte <.30,<.31,<.32,<.33

.return_hi	!byte >.8
		!byte >.9,>.9,>.9,>.9
		!byte >.9,>.9,>.9,>.9
		!byte >.10,>.11,>.12,>.13
		!byte >.14,>.15,>.16,>.17
		!byte >.18,>.19,>.20,>.21
		!byte >.22,>.23,>.24,>.25
		!byte >.26,>.27,>.28,>.29
		!byte >.30,>.31,>.32,>.33


		;;;;;;;; . ;;;;;;;;

		!macro collision_mask i,~.mask {
		+lda_imm ~.mask
		beq .skip
		jsr collision_check_mask

.skip		!if i < 32 {
		lda actor_order_stack-i
		sta collision_window+i%8
		}
		}

.start

.8		+collision_mask 8, ~collision_mask8
.9		+collision_mask 9, ~collision_mask9
.10		+collision_mask 10,~collision_mask10
.11		+collision_mask 11,~collision_mask11
.12		+collision_mask 12,~collision_mask12
.13		+collision_mask 13,~collision_mask13
.14		+collision_mask 14,~collision_mask14
.15		+collision_mask 15,~collision_mask15
.16		+collision_mask 16,~collision_mask16
.17		+collision_mask 17,~collision_mask17
.18		+collision_mask 18,~collision_mask18
.19		+collision_mask 19,~collision_mask19
.20		+collision_mask 20,~collision_mask20
.21		+collision_mask 21,~collision_mask21
.22		+collision_mask 22,~collision_mask22
.23		+collision_mask 23,~collision_mask23
.24		+collision_mask 24,~collision_mask24
.25		+collision_mask 25,~collision_mask25
.26		+collision_mask 26,~collision_mask26
.27		+collision_mask 27,~collision_mask27
.28		+collision_mask 28,~collision_mask28
.29		+collision_mask 29,~collision_mask29
.30		+collision_mask 30,~collision_mask30
.31		+collision_mask 31,~collision_mask31
.32		+collision_mask 32,~collision_mask32
.33		rts


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		!macro collision_bounding_box .continue {
		lda actor_xpos,x	;; check standard 24x21 bounding box
		clc
		adc #12+1
		sbc actor_xpos,y
		cmp #24
		bcs .continue

		lda actor_ypos,x
		adc #21+1
		sbc actor_ypos,y
		cmp #42
		bcs .continue
		}

collision_check_mask !zone
		tax
		ldy collision_lsb,x
		and .rbit,y

.outer		sta collision_outer_mask
		ldx collision_window,y
		stx collision_outer_actor

		ldy actor_class,x	;; cache the collision class early on
		ldx c_class,y
		stx collision_outer_c_class

		tax

.inner		ldy collision_lsb,x
		and .rbit,y
		sta collision_inner_mask

		ldx collision_window,y

		ldy actor_class,x	;; compare collision masks
		lda c_mask,y
		and collision_outer_c_class
		beq .continue

		ldy collision_outer_actor
		+collision_bounding_box .continue

		tya
		sta actor_collision,x
		txa
		sta actor_collision,y

.continue	lax collision_inner_mask
		bne .inner

		lax collision_outer_mask
		ldy collision_lsb,x
		and .rbit,y
		bne .outer
		rts

		;;
.rbit		!byte %11111110
		!byte %11111101
		!byte %11111011
		!byte %11110111
		!byte %11101111
		!byte %11011111
		!byte %10111111
		!byte %01111111


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		+align
collision_lsb	!byte 0
		!for i,1,256 {
		!if i & %00000001 { !byte 0 } else {
		!if i & %00000010 { !byte 1 } else {
		!if i & %00000100 { !byte 2 } else {
		!if i & %00001000 { !byte 3 } else {
		!if i & %00010000 { !byte 4 } else {
		!if i & %00100000 { !byte 5 } else {
		!if i & %01000000 { !byte 6 } else {
		!if i & %10000000 { !byte 7 } } } } } } } }
		}