;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; far branches. also take the opprotunity to optimize branches when the
;; target label is known and within range
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		!macro _branch .label,.pos_opc,.neg_opc {
		!ifdef .label {
		!if .label >= *-126 AND .label <= *+129 {
		!warn "near branch"
		!byte .pos_opc,.label-(*+2)
		} else {
		!byte .neg_opc,3
		jmp .label
		}
		} else {
		!byte .neg_opc,3
		jmp .label
		}
		}

		!macro bne .l { +_branch .l,opc_bne_rel,opc_beq_rel }
		!macro beq .l { +_branch .l,opc_beq_rel,opc_bne_rel }
		!macro bpl .l { +_branch .l,opc_bpl_rel,opc_bmi_rel }
		!macro bmi .l { +_branch .l,opc_bmi_rel,opc_bpl_rel }
		!macro bcc .l { +_branch .l,opc_bcc_rel,opc_bcs_rel }
		!macro bcs .l { +_branch .l,opc_bcs_rel,opc_bcc_rel }
		!macro bvc .l { +_branch .l,opc_bvc_rel,opc_bvs_rel }
		!macro bvs .l { +_branch .l,opc_bvs_rel,opc_bvc_rel }


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; optimize far branches to common labels by attempting to reuse absolute
;; (backwards) jumps within the local branch range. note that this scheme
;; stores the last absolute jmp's address in the high-word of the "label" and
;; requires the label's initial value to be known before its first used
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		!macro common ~.label {
		!set .label = (*<<16)+*
		}

		!macro jmp ~.label {
		!ifdef .label { } else { !serious "undefined label" }
		!if .label < $10000 { !serious "not a branch label" }

.real		= .label & $ffff

		!set .label = (*<<16)+.real
		jmp .real
		}

		!macro _branch ~.label,.pos_opc,.neg_opc {
		!ifdef .label { } else { !serious "undefined label" }
		!if .label < $10000 { !serious "not a branch label" }

.real		= .label & $ffff
.last		= .label>>16

		!if .last >= *-126 AND .last <= *+129 {
		!byte .pos_opc,.last-(*+2)
		} else {
		!byte .neg_opc,.dont-(*+2)
		!set .label = (*<<16)+.real
		jmp .real
.dont		}
		}

		!macro bne ~.l { +_branch ~.l,opc_bne_rel,opc_beq_rel }
		!macro beq ~.l { +_branch ~.l,opc_beq_rel,opc_bne_rel }
		!macro bpl ~.l { +_branch ~.l,opc_bpl_rel,opc_bmi_rel }
		!macro bmi ~.l { +_branch ~.l,opc_bmi_rel,opc_bpl_rel }
		!macro bcc ~.l { +_branch ~.l,opc_bcc_rel,opc_bcs_rel }
		!macro bcs ~.l { +_branch ~.l,opc_bcs_rel,opc_bcc_rel }
		!macro bvc ~.l { +_branch ~.l,opc_bvc_rel,opc_bvs_rel }
		!macro bvs ~.l { +_branch ~.l,opc_bvs_rel,opc_bvc_rel }
