fade_vic_palette = vic_cbg0	;; $d021-$d026
fade_vic_palette_size = 6


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; a = fade level (0-7)
;; note that the actors lag a frame behind everything else, unfortunately
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
fade_update	!zone
		asl
		asl
		asl
		asl

		sta .palette_table+1
		sta .actor_table+1
		sta .status_table1+1
		sta .status_table2+1

		ora #$80
		sta r0
		lda #>fade_tab
		sta r1

		;; fade vic palette
		ldx #fade_vic_palette_size-1
.palette_loop	ldy fade_vic_buf,x
.palette_table	lda fade_tab,y
		sta fade_vic_palette,x
		dex
		bpl .palette_loop

		;; fade color ram
		ldx #38-1
.map_top	ldy fade_map_buf,x
		lda (r0),y
		sta vic_color,x

		!for i,0,6 {
		ldy vic_screen+i*80+40,x
		lda (r0),y
		sta vic_color+i*80+80,x
		}
		dex
		bpl .map_top

		ldx #38-1
.map_bottom	!for i,6,6 {
		ldy vic_screen+i*80+40,x
		lda (r0),y
		sta vic_color+i*80+80,x
		}
		dex
		bpl .map_bottom

		;; fade statusbar colors
		ldy #39-1
.status_loop	lda fade_status_buf,y
		and #$0f
		tax
.status_table1	lda fade_tab,x
		sta r2

		lda fade_status_buf,y
		asr #$f0
		lsr
		lsr
		lsr
		tax
.status_table2	lda fade_tab,x

		asl
		asl
		asl
		asl
		ora r2
		sta vic_panel_matrix,y

		dey
		bpl .status_loop

		;; fade actor colors
		ldy #actor_limit-1
.actor_loop	lda fade_actor_buf,y
		ldx #$0f
		sbx #$00
		and #$80
.actor_table	ora fade_tab,x
		sta actor_attrib,y
		dey
		bpl .actor_loop
		rts


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; buffer the initial or target color values when starting a fade
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
fade_lock	!zone

		;; preserve vic palette
		ldx #fade_vic_palette_size-1
.palette_loop	lda fade_vic_palette,x
		and #$0f
		sta fade_vic_buf,x
		dex
		bpl .palette_loop

		;; preserve color ram
		ldy #38-1
.map_loop	lda vic_color,y
		and #$0f
		sta fade_map_buf,y
		!for i,0,12 {
		lda vic_color+i*80+80,y
		and #$0f
		sta vic_screen+i*80+40,y
		}
		lda vic_panel_matrix,y
		sta fade_status_buf,y
		dey
		bpl .map_loop

		;; preserve statusbar colors
		ldy #39-1
.status_loop	lda vic_panel_matrix,y
		sta fade_status_buf,y
		dey
		bpl .status_loop

		;; preserve actor colors
		ldy #actor_limit-1
.actor_loop	lda actor_attrib,y
		sta fade_actor_buf,y
		dey
		bpl .actor_loop
		rts


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; fadeout the basic screen
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		!macro fadeout_basic {
		ldx #14
.save_fixed	lda vic_cborder-1,x
		and #$0f
		sta r2-1,x
		dex
		bne .save_fixed

.save_screen	!for i,0,4 {
		lda vic_color+i*$100,x
		and #$0f
		sta vic_screen+i*$100,x
		}
		dex
		bne .save_screen

		;;;;;;;;

		lda #>fade_tab
		sta r1
		ldx #$80
		stx r0

.loop		lda vic_line
		bne .loop
		lda vic_controlv
		bmi .loop

		lax r0
		sbx #$10
		stx r0
		bmi .return

		ldx #14
.fade_fixed	ldy r2-1,x
		lda (r0),y
		sta vic_cborder-1,x
		dex
		bne .fade_fixed

		lda #>$0300
	;;	ldx #$00

.fade_screen	pha
		eor #>(vic_screen EOR $0300)

		sta .src0+2
		sta .src1+2
		sta .src2+2
		sta .src3+2

		eor #>(vic_screen EOR vic_color)

		sta .dst0+2
		sta .dst1+2
		sta .dst2+2
		sta .dst3+2

.pageloop	= *

.src0		ldy $ff00,x
		lda (r0),y
.dst0		sta $ff00,x

.src1		ldy $ff01,x
		lda (r0),y
.dst1		sta $ff01,x

.src2		ldy $ff02,x
		lda (r0),y
.dst2		sta $ff02,x

.src3		ldy $ff03,x
		lda (r0),y
.dst3		sta $ff03,x

		txa
		sbx #-4
		bcc .pageloop

		pla
		adc #-1-1
		bne .fade_screen
		beq .loop		;; bra

.return		}