;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; calculate the angle between actor x and y, with 5-bit precision. the angle
;; is returned in a.
;; (preserves x, destroys r0-r1)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
math_atan2	!zone
.octant		= r0
.dxdy		= r1

		lda actor_xpos,x
		sbc actor_xpos,y
		bcs .x_positive
		eor #$ff
.x_positive	rol .octant

		sta .dx+1

		lda actor_ypos,x
		sbc actor_ypos,y
		bcs .y_positive
		eor #$ff
.y_positive	rol .octant

		cmp #$80		;; adjust for the aspect ratio
		ror
		tay

.dx		lda math_log2
		sbc math_log2,y
		bcc .x_major
		eor #$ff

.x_major	sta .dxdy2+1

		lda .octant
		rol
		and #7
		tay

.dxdy2		lda math_atan

		lsr
		lsr
		lsr

		eor .octant_adjust,y
		rts

.octant_adjust	!byte %00111111		;; x+,y+,|x|>|y|
		!byte %00000000		;; x+,y+,|x|<|y|
		!byte %11000000		;; x+,y-,|x|>|y|
		!byte %11111111		;; x+,y-,|x|<|y|
		!byte %01000000		;; x-,y+,|x|>|y|
		!byte %01111111		;; x-,y+,|x|<|y|
		!byte %10111111		;; x-,y-,|x|>|y|
		!byte %10000000		;; x-,y-,|x|<|y|