;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; define various useful opcodes to clarify code generation
;;
;; addressing modes:
;; imp
;; imm #$??
;; abs $????
;; abx $????,x
;; aby $????,y
;; zpg $??
;; zpx $??,x
;; zpy $??,y
;; ind ($????)
;; inx ($??,x)
;; iny ($??),y
;; rel $????
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
opc_brk_imm	= $00
opc_ora_inx	= $01
opc_jam_imp	= $02
opc_slo_inx	= $03
opc_nop_zpg	= $04
opc_ora_zpg	= $05
opc_asl_zpg	= $06
opc_slo_zpg	= $07
opc_php_imp	= $08
opc_ora_imm	= $09
opc_asl_imp	= $0a
opc_anc_imm	= $0b
opc_nop_abs	= $0c
opc_ora_abs	= $0d
opc_asl_abs	= $0e
opc_slo_abs	= $0f

opc_bpl_rel	= $10
opc_ora_iny	= $11
;opc_jam_imp	= $12
opc_slo_zpy	= $13
opc_nop_zpx	= $14
opc_ora_zpx	= $15
opc_asl_zpx	= $16
opc_slo_zpx	= $17
opc_clc_imp	= $18
opc_ora_aby	= $19
;opc_nop_imp	= $1a
opc_slo_aby	= $1b
opc_nop_abx	= $1c
opc_ora_abx	= $1d
opc_asl_abx	= $1e
opc_slo_abx	= $1f

opc_jsr_abs	= $20
opc_and_inx	= $21
;opc_jam_imp	= $22
opc_rla_inx	= $23
opc_bit_zpg	= $24
opc_and_zpg	= $25
opc_rol_zpg	= $26
opc_rla_zpg	= $27
opc_plp_imp	= $28
opc_and_imm	= $29
opc_rol_imp	= $2a
;opc_anc_imm	= $2b
opc_bit_abs	= $2c
opc_and_abs	= $2d
opc_rol_abs	= $2e
opc_rla_abs	= $2f

opc_bmi_rel	= $30
opc_and_iny	= $31
;opc_jam_imp	= $32
opc_rla_iny	= $33
;opc_nop_zpx	= $34
opc_and_zpx	= $35
opc_rol_zpx	= $36
opc_rla_zpx	= $37
opc_sec_imp	= $38
opc_and_aby	= $39
;opc_nop_imp	= $3a
opc_rla_aby	= $3b
;opc_nop_abx	= $3c
opc_and_abx	= $3d
opc_rol_abx	= $3e
opc_rla_abx	= $3f

opc_rti_imp	= $40
opc_eor_inx	= $41
;opc_jam_imp	= $42
opc_sre_inx	= $43
;opc_nop_zpg	= $44
opc_eor_zpg	= $45
opc_lsr_zpg	= $46
opc_sre_zpg	= $47
opc_pha_imp	= $48
opc_eor_imm	= $49
opc_lsr_imp	= $4a
opc_asr_imm	= $4b
opc_jmp_abs	= $4c
opc_eor_abs	= $4d
opc_lsr_abs	= $4e
opc_sre_abs	= $4f

opc_bvc_rel	= $50
opc_eor_iny	= $51
;opc_jam_imp	= $52
opc_sre_iny	= $53
;opc_nop_zpx	= $54
opc_eor_zpx	= $55
opc_lsr_zpx	= $56
opc_sre_zpx	= $57
opc_cli_imp	= $58
opc_eor_aby	= $59
;opc_nop_imp	= $5a
opc_sre_aby	= $5b
;opc_nop_abx	= $5c
opc_eor_abx	= $5d
opc_lsr_abx	= $5e
opc_sre_abx	= $5f

opc_rts_imp	= $60
opc_adc_inx	= $61
;opc_jam_imp	= $62
opc_rra_inx	= $63
;opc_nop_zpg	= $64
opc_adc_zpg	= $65
opc_ror_zpg	= $66
opc_rra_zpg	= $67
opc_pla_imp	= $68
opc_adc_imm	= $69
opc_ror_imp	= $6a
opc_arr_imm	= $6b
opc_jmp_ind	= $6c
opc_adc_abs	= $6d
opc_ror_abs	= $6e
opc_rra_abs	= $6f

opc_bvs_rel	= $70
opc_adc_iny	= $71
;opc_jam_imp	= $72
opc_rra_iny	= $73
;opc_nop_zpx	= $74
opc_adc_zpx	= $75
opc_ror_zpx	= $76
opc_rra_zpx	= $77
opc_sei_imp	= $78
opc_adc_aby	= $79
;opc_nop_imp	= $7a
opc_rra_aby	= $7b
;opc_nop_abx	= $7c
opc_adc_abx	= $7d
opc_ror_abx	= $7e
opc_rra_abx	= $7f

opc_nop_imm	= $80
opc_sta_inx	= $81
;opc_nop_imm	= $82
opc_sax_inx	= $83
opc_sty_zpg	= $84
opc_sta_zpg	= $85
opc_stx_zpg	= $86
opc_sax_zpg	= $87
opc_dey_imp	= $88
;opc_nop_imm	= $89
opc_txa_imp	= $8a
opc_ane_imm	= $8b
opc_sty_abs	= $8c
opc_sta_abs	= $8d
opc_stx_abs	= $8e
opc_sax_abs	= $8f

opc_bcc_rel	= $90
opc_sta_iny	= $91
;opc_jam_imp	= $92
opc_sha_abx	= $93
opc_sty_zpx	= $94
opc_sta_zpx	= $95
opc_stx_zpy	= $96
opc_sax_zpy	= $97
opc_tya_imp	= $98
opc_sta_aby	= $99
opc_txs_imp	= $9a
opc_shs_abx	= $9b
opc_shy_aby	= $9c
opc_sta_abx	= $9d
opc_shx_aby	= $9e
opc_sha_aby	= $9f

opc_ldy_imm	= $a0
opc_lda_inx	= $a1
opc_ldx_imm	= $a2
opc_lax_zpx	= $a3
opc_ldy_zpg	= $a4
opc_lda_zpg	= $a5
opc_ldx_zpg	= $a6
opc_lax_zpg	= $a7
opc_tay_imp	= $a8
opc_lda_imm	= $a9
opc_tax_imp	= $aa
opc_lxa_imm	= $ab
opc_ldy_abs	= $ac
opc_lda_abs	= $ad
opc_ldx_abs	= $ae
opc_lax_abs	= $af

opc_bcs_rel	= $b0
opc_lda_iny	= $b1
;opc_jam_imp	= $b2
opc_lax_iny	= $b3
opc_ldy_zpx	= $b4
opc_lda_zpx	= $b5
opc_ldx_zpy	= $b6
opc_lax_zpy	= $b7
opc_clv_imp	= $b8
opc_lda_aby	= $b9
opc_tsx_imp	= $ba
opc_lae_aby	= $bb
opc_ldy_abx	= $bc
opc_lda_abx	= $bd
opc_ldx_aby	= $be
opc_lax_aby	= $bf

opc_cpy_imm	= $c0
opc_cpx_inx	= $c1
;opc_nop_imm	= $c2
opc_dcp_inx	= $c3
opc_cpy_zpg	= $c4
opc_cmp_zpg	= $c5
opc_dec_zpg	= $c6
opc_dcp_zpg	= $c7
opc_iny_imp	= $c8
opc_cmp_imm	= $c9
opc_dex_imp	= $ca
opc_sbx_imm	= $cb
opc_cpy_abs	= $cc
opc_cmp_abs	= $cd
opc_dec_abs	= $ce
opc_dcp_abs	= $cf

opc_bne_rel	= $d0
opc_cmp_iny	= $d1
;opc_jam_imp	= $d2
opc_dcp_iny	= $d3
;opc_nop_zpx	= $d4
opc_cmp_zpx	= $d5
opc_dec_zpx	= $d6
opc_dcp_zpx	= $d7
opc_cld_imp	= $d8
opc_cmp_aby	= $d9
;opc_nop_imp	= $da
opc_dcp_aby	= $db
;opc_nop_abx	= $dc
opc_cmp_abx	= $dd
opc_dec_abx	= $de
opc_dcp_abx	= $df

opc_cpx_imm	= $e0
opc_sbc_inx	= $e1
;opc_nop_imm	= $e2
opc_isb_inx	= $e3
opc_cpx_zpg	= $e4
opc_sbc_zpg	= $e5
opc_inc_zpg	= $e6
opc_isb_zpg	= $e7
opc_inx_imp	= $e8
opc_sbc_imm	= $e9
opc_nop_imp	= $ea
;opc_sbc_imm	= $eb
opc_cpx_abs	= $ec
opc_sbc_abs	= $ed
opc_inc_abs	= $ee
opc_isb_abs	= $ef

opc_beq_rel	= $f0
opc_sbc_iny	= $f1
;opc_jam_imp	= $f2
opc_isb_iny	= $f3
;opc_nop_zpx	= $f4
opc_sbc_zpx	= $f5
opc_inc_zpx	= $f6
opc_isb_zpx	= $f7
opc_sed_imp	= $f8
opc_sbc_aby	= $f9
;opc_nop_imp	= $fa
opc_isb_aby	= $fb
;opc_nop_abx	= $fc
opc_sbc_abx	= $fd
opc_inc_abx	= $fe
opc_isb_abx	= $ff