;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		!macro panel_prepare {
		!if panel_ylock < 0 {
		ldx view_ypos
		} else {
		ldx #panel_ylock
		}

		lda panel_linetab,x
		sta panel_line
		lda panel_irqtab_lo,x
		sta panel_irq+0
		lda panel_irqtab_hi,x
		sta panel_irq+1
		}

panel_linetab	!byte panel_line00
		!byte panel_line01
		!byte panel_line02
		!byte panel_line03
		!byte panel_line04
		!byte panel_line05
		!byte panel_line06
		!byte panel_line07
		!byte panel_line10
		!byte panel_line11
		!byte panel_line12
		!byte panel_line13
		!byte panel_line14
		!byte panel_line15
		!byte panel_line16
		!byte panel_line17

panel_irqtab_lo	!byte <panel_irq00
		!byte <panel_irq01
		!byte <panel_irq02
		!byte <panel_irq03
		!byte <panel_irq04
		!byte <panel_irq05
		!byte <panel_irq06
		!byte <panel_irq07
		!byte <panel_irq10
		!byte <panel_irq11
		!byte <panel_irq12
		!byte <panel_irq13
		!byte <panel_irq14
		!byte <panel_irq15
		!byte <panel_irq16
		!byte <panel_irq17

panel_irqtab_hi	!byte >panel_irq00
		!byte >panel_irq01
		!byte >panel_irq02
		!byte >panel_irq03
		!byte >panel_irq04
		!byte >panel_irq05
		!byte >panel_irq06
		!byte >panel_irq07
		!byte >panel_irq10
		!byte >panel_irq11
		!byte >panel_irq12
		!byte >panel_irq13
		!byte >panel_irq14
		!byte >panel_irq15
		!byte >panel_irq16
		!byte >panel_irq17


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
panel_blank_line = $ee
panel_ylock	= -1

panel_line00	= panel_blank_line-1
panel_line01	= panel_blank_line-1
panel_line02	= panel_blank_line-1
panel_line03	= panel_blank_line-1
panel_line04	= panel_blank_line-1
panel_line05	= panel_blank_line-2
panel_line06	= panel_blank_line-2
panel_line07	= panel_blank_line-1
panel_line10	= panel_blank_line-1
panel_line11	= panel_blank_line-2
panel_line12	= panel_blank_line-1
panel_line13	= panel_blank_line-1
panel_line14	= panel_blank_line-1
panel_line15	= panel_blank_line-1
panel_line16	= panel_blank_line-2
panel_line17	= panel_blank_line-1

panel_irq00	= panel_irq_even	;; *
panel_irq01	= panel_irq_odd		;; *
panel_irq02	= panel_irq02		;; !
panel_irq03	= panel_irq_odd		;; *
panel_irq04	= panel_irq_even	;; *
panel_irq05	= panel_irq05		;; !
panel_irq06	= panel_irq06		;; !
panel_irq07	= panel_irq_odd		;; *
panel_irq10	= panel_irq_even	;; *
panel_irq11	= panel_irq11		;; !
panel_irq12	= panel_irq12		;; !
panel_irq13	= panel_irq_odd		;; *
panel_irq14	= panel_irq_even	;; *
panel_irq15	= panel_irq_odd		;; *
panel_irq16	= panel_irq16		;; !
panel_irq17	= panel_irq_odd		;; *


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		+align

		!zone

panel_irq06	= *
panel_irq16	= *
	;;	sax cia2_cra

		sta irq_save_a

		lda #%00010000+7
		sta vic_controlv

		sta cia2_cra

		lda #panel_line16
.loop		cmp vic_line
		beq .loop

		jmp .enter

		;;;;;;;;

panel_irq02	= *
panel_irq12	= *
		sax cia2_crb

panel_irq_even	sta irq_save_a

.enter		lda #$1f
		eor cia1_ta_lo
		cmp #$1a
		sta *+4
		bcc *

		cmp #$c9		;; 00-01
		cmp #$c9		;; 02-03
		cmp #$c9		;; 04-05
		cmp #$c9		;; 06-07
		cmp #$c9		;; 08-09
		cmp #$c9		;; 0a-0b
		cmp #$c9		;; 0c-0d
		cmp #$c9		;; 0e-0f
		cmp #$c9		;; 10-11
		cmp #$c9		;; 12-13
		cmp #$c9		;; 14-15
		cmp #$c9		;; 16-17
		cmp $ea			;; 18-19

		lda #%01110000+7
		sta vic_controlv

		lda #%01111111
		sta cia2_icr
		lda #%00111000
		sta vic_ram
		lda #%00000000
		sta vic_controlh

		lda #$7f XOR $20
		eor cia1_ta_lo		;; $04-$15
		cmp #$18
		sta *+4
		bcc *

		cmp #$c9		;; 00-01
		cmp #$c9		;; 02-03

		cmp #$c9		;; 04-05
		cmp #$c9		;; 06-07
		cmp #$c9		;; 08-09
		cmp #$c9		;; 0a-0b
		cmp #$c9		;; 0c-0d
		cmp #$c9		;; 0e-0f
		cmp #$c9		;; 10-11
		cmp #$c9		;; 12-13
		cmp #$c9		;; 14-15
		cmp $ea			;; 16-17

	;;	+dbg_limits 25,12

		lda #%00110000+7
		sta vic_controlv
		jmp panel_next_irq


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
panel_irq11	!zone
		sta irq_save_a

		lda #panel_line11;vic_line
		!for i,4 {
		cmp vic_line
		bne .go
		}
		beq .go

.go		= *+2

panel_irq_odd	!zone
		sta irq_save_a

		lda #$7f XOR $20
		eor cia1_ta_lo		;; $05 - $1b

		cmp #$1c
		sta *+4
		bcc *

		cmp #$c9		;; 00-01
		cmp #$c9		;; 02-03
		cmp #$c9		;; 04-05
		cmp #$c9		;; 06-07
		cmp #$c9		;; 08-09
		cmp #$c9		;; 0a-0b
		cmp #$c9		;; 0c-0d
		cmp #$c9		;; 0e-0f
		cmp #$c9		;; 10-11
		cmp #$c9		;; 12-13
		cmp #$c9		;; 14-15
		cmp #$c9		;; 16-17
		cmp #$c9		;; 18-19
		cmp $ea			;; 1a-1b

	;;	+dbg_limits 25,12
	;;
	;;	inc $d021
	;;	inc $d021
	;;	inc $d021
	;;	dec $d021
	;;	dec $d021
	;;	dec $d021

		lda #%01110000+7
		sta vic_controlv

		lda #%01111111
		sta cia2_icr
		lda #%00111000
		sta vic_ram
		lda #%00000000
		sta vic_controlh

		lda #$1f
		eor cia1_ta_lo		;; $04-$16
		cmp #$18
		sta *+4
		bcc *

		cmp #$c9		;; 00-01
		cmp #$c9		;; 02-03

		cmp #$c9		;; 04-05
		cmp #$c9		;; 06-07
		cmp #$c9		;; 08-09
		cmp #$c9		;; 0a-0b
		cmp #$c9		;; 0c-0d
		cmp #$c9		;; 0e-0f
		cmp #$c9		;; 10-11
		cmp #$c9		;; 12-13
		cmp #$c9		;; 14-15
		cmp $ea			;; 16-17

	;;	+dbg_limits 25,12

		lda #%00110000+7
		sta vic_controlv
		jmp panel_next_irq


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
panel_irq05	!zone
		sta irq_save_a
		stx irq_save_x

		ldx #101
		lda #%01110000+7

.wait1		bit cia1_ta_lo
		bvc .wait1
.wait2		cpx cia1_ta_lo
		bcc .wait2

		sta vic_controlv

		lda #%00111000
		sta vic_ram
		lda #%00000000
		sta vic_controlh

		lda #%00110000+7

.loop3		!for i,8 {
		bit cia1_ta_lo
		bvs .wait3
		}
		bit cia1_ta_lo
		bvc .loop3

.wait3		sta vic_controlv

		lda #%01111111
		sta cia2_icr

		ldx irq_save_x

panel_next_irq	lsr vic_irq
		lda #<bottom_line
		sta vic_line
		lda #<bottom_irq
		sta cpu_irq+0
		lda #>bottom_irq
		sta cpu_irq+1

		lda irq_save_a
		rti