;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; script commands
;;
;; sc_wait .ticks
;; sc_goto .target
;; sc_buzzer .xpos
;; sc_streaker .xpos
;; sc_seeker .xpos
;; sc_sweeper .xpos
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		!macro sc_wait .ticks {
		!byte script_cmd_wait-script_cmd
		!byte .ticks
		}

		!macro sc_goto .target {
		!byte script_cmd_goto-script_cmd
		!word .target
		}

		!macro sc_buzzer_i .xpos {
		!byte script_cmd_buzzer-script_cmd
		!byte .xpos-4
		}

		!macro sc_seeker_i .xpos {
		!byte script_cmd_seeker-script_cmd

		!if (a_player_xmin+a_player_xmax) > .xpos*2 {
		!byte (.xpos&-2)+0
		} else {
		!byte (.xpos&-2)+1
		}
		}

		!macro sc_streaker_i .xpos {
		!byte script_cmd_streaker-script_cmd
		!byte .xpos
		}

		!macro sc_sweeper_left_i .ypos {
		!byte script_cmd_sweeper-script_cmd
		!byte (.ypos>>1)+$00
		}

		!macro sc_sweeper_right_i .ypos {
		!byte script_cmd_sweeper-script_cmd
		!byte (.ypos>>1)+$80
		}


		;;;;;;;; floating point versions ;;;;;;

		!macro sc_buzzer .xpos {
		+sc_buzzer_i int(.xpos*4+10+76)
		}
		!macro sc_seeker .xpos {
		+sc_seeker_i int(.xpos*4+10+76)
		}

		!macro sc_streaker .xpos {
		+sc_streaker_i int(.xpos*4+10+76)
		}

		!macro sc_sweeper_left .ypos {
		+sc_sweeper_left_i int(.ypos*8+135)
		}
		!macro sc_sweeper_right .ypos {
		+sc_sweeper_right_i int(.ypos*8+135)
		}


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; the script interpreter
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		!zone
.waiting	dec script_wait
		rts

script_execute	+ldy_imm ~script_wait,0
		bne .waiting

script_continue +common ~script_continue_cb

		lda (script),y
		iny
		sta script_cmd-1
		bne script_cmd

script_cmd	= *


		;;;;;;;; jump table for the script commands ;;;;;;;;

		;; baddies
script_cmd_buzzer
		jmp a_scripted_buzzer
script_cmd_streaker
		jmp a_scripted_streaker
script_cmd_seeker
		jmp a_scripted_seeker
script_cmd_sweeper
		jmp a_scripted_sweeper

		;;
script_cmd_goto	lax (script),y
		iny
		lda (script),y
		stx script+0
		sta script+1
		ldy #0
		beq script_continue

		;;
script_cmd_wait	lda (script),y
		iny
		sta script_wait

		tya
		clc
		adc script_lo
		sta script_lo
		bcc .return
		inc script_hi
.return		rts