dbg_statusbar = 0

		;; columns
statusbar_score1 = 13
statusbar_score2 = 21
statusbar_charge1 = 4
statusbar_charge2 = 28
statusbar_lives1 = 2
statusbar_lives2 = 37


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; a = column*4
;; x = char address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
statusbar_putchar !zone
		asl
		tay
		bcs .high

		!for i,0,8 {
		lda statusbar_font+i,x
		sta vic_panel_bitmap+i,y
		}
		rts

.high		!for i,0,8 {
		lda statusbar_font+i,x
		sta vic_panel_bitmap+i+$100,y
		}
		rts


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; dump some debugging info
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		!macro dbg_statusbar_idle .column {
		lda game_idle_hi
		asl
		asl
		asl
		tax
		lda #.column*4+0
		jsr statusbar_putchar

		lda game_idle_lo
		asr #$f0
		tax
		lda #.column*4+4
		jsr statusbar_putchar

		lda game_idle_lo
		and #$0f
		asl
		asl
		asl
		tax
		lda #.column*4+8
		jsr statusbar_putchar
		}

		!macro dbg_statusbar_actors .column {
		ldx actor_count
		ldy #-1

.loop		iny
		txa
		sbx #10
		bcs .loop

		asl
		asl
		asl
		tax

		tya
		asl
		asl
		asl
		sta r0

		lda #.column*4+4
		jsr statusbar_putchar

		ldx r0
		lda #.column*4+0
		jsr statusbar_putchar
		}


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; print a pair of digits of one player's score
;; y = digit # pair (0-5)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		!macro statusbar_score {
		lda a_player_score,y
		lsr
		ldx #%01111000
		sax r0
		rol
		asl
		asl
		asl
		sbx #%00000000

		lda statusbar_score_offset,y
		pha
	;;	sec
		sbc #-4
		jsr statusbar_putchar

		ldx r0
		pla
		jsr statusbar_putchar
		}

		+single_page 6
statusbar_score_offset
		!for i,3 {
		!byte (3-i)*8+statusbar_score1*4
		!byte (3-i)*8+statusbar_score2*4
		}


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		!macro statusbar_lives {
		lda a_player_lives+a_player_1st
		bmi .undefined1
		asl
		asl
		asl
		tax
		lda #statusbar_lives1*4
		jsr statusbar_putchar

.undefined1	lda a_player_lives+a_player_2nd
		bmi .undefined2
		asl
		asl
		asl
		tax
		lda #statusbar_lives2*4
		jsr statusbar_putchar

.undefined2	}


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; show the a player's energy bar.
;; x = player actor (a_player_1st/a_player_2nd)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
		!macro statusbar_battery {
		lda #vicclr_green*17
		ldy a_player_charging,x
		beq .loading

		+a_player_laser_animate

.loading	pha
		ldy statusbar_battery_offset,x

		lda a_player_battery,x
		lsr
		lsr
		ldx #%11111000
		sax r0
		ldx #%00000111
		sax r1

		lsr
		lsr
		lsr
		eor #$07
		tax

		pla
		!for i,0,8 {
		and statusbar_battery_color+i,x
		sta vic_panel_matrix+statusbar_charge1+i,y
		}

		tya
		asl
		asl
		asl
		ora r0
		tay

		ldx r1
		lda statusbar_battery_pattern,x

		!for i,0,8 {
		sta vic_panel_bitmap+statusbar_charge1*8+i,y
		}
		}

		+single_page 8
statusbar_battery_pattern
		!for i,0,8 {
		!byte $ff>>i
		}

		+single_page 8
statusbar_battery_color
		!fill 7,$ff
		!byte $0f
		!fill 8,$00

statusbar_battery_offset = *-a_player_1st
		!byte 0
		!byte statusbar_charge2-statusbar_charge1


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
statusbar_redraw !zone
		lda .index
		ldx #%00000001
		sbx #-a_player_1st
		+statusbar_battery

		!if dbg_statusbar <> 0 {
		+dbg_statusbar_idle statusbar_score1
		+dbg_statusbar_actors statusbar_score2
		}

		+ldy_imm ~.index
		bpl .score

		ldy #6-1
		sty .index
		+statusbar_lives
		rts
.score		dec .index
		!if dbg_statusbar = 0 {
		+statusbar_score
		}
		rts



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
statusbar_clear	!zone
		lda #spr_blank
		ldx #8
.sprpat		dex
		sta vic_panel_sprpat,x
		bne .sprpat

		ldx #20
.matrix1	lda #vicclr_cyan*16+vicclr_gray1
		sta vic_panel_matrix,x
		lda #vicclr_lred*16+vicclr_brown
		sta vic_panel_matrix+20,x
		dex
		bpl .matrix1

		lda #$00

		ldx #<320
.bitmap1	sta vic_panel_bitmap+$100-1,x
		dex
		bne .bitmap1
.bitmap2	sta vic_panel_bitmap+$000,x
		dex
		bne .bitmap2

		lda #vicclr_black*16+vicclr_gray1
		sta vic_panel_matrix+statusbar_charge1-1
	;;	sta vic_panel_matrix+statusbar_charge1+8
		lda #vicclr_black*16+vicclr_brown
		sta vic_panel_matrix+statusbar_charge2-1
	;;	sta vic_panel_matrix+statusbar_charge2+8
		lda #vicclr_gray1+vicclr_lred*16
		sta vic_panel_matrix+(statusbar_lives1-1)
		lda #vicclr_brown+vicclr_lred*16
		sta vic_panel_matrix+(statusbar_lives2+1)

		ldx #8-1
.charge		lda #%00000001
		sta vic_panel_bitmap+(statusbar_charge1-1)*8,x
		sta vic_panel_bitmap+(statusbar_charge2-1)*8,x

		lda statusbar_heart,x
		sta vic_panel_bitmap+(statusbar_lives1-1)*8,x
		sta vic_panel_bitmap+(statusbar_lives2+1)*8,x
		dex
		bpl .charge
		rts


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
statusbar_font	!byte %.#####..
		!byte %##...##.
		!byte %##...##.
		!byte %##...##.
		!byte %##...##.
		!byte %##...##.
		!byte %##...##.
		!byte %.#####..

		!byte %...##...
		!byte %..###...
		!byte %...##...
		!byte %...##...
		!byte %...##...
		!byte %...##...
		!byte %...##...
		!byte %..####..

		!byte %.#####..
		!byte %##...##.
		!byte %##...##.
		!byte %....##..
		!byte %...##...
		!byte %..##....
		!byte %.##.....
		!byte %#######.

		!byte %.#####..
		!byte %##...##.
		!byte %.....##.
		!byte %..####..
		!byte %.....##.
		!byte %.....##.
		!byte %##...##.
		!byte %.#####..

		!byte %...###..
		!byte %..####..
		!byte %.##.##..
		!byte %##..##..
		!byte %##..##..
		!byte %#######.
		!byte %....##..
		!byte %....##..

		!byte %#######.
		!byte %##......
		!byte %##......
		!byte %######..
		!byte %##...##.
		!byte %.....##.
		!byte %##...##.
		!byte %.#####..

		!byte %.#####..
		!byte %##...##.
		!byte %##......
		!byte %######..
		!byte %##...##.
		!byte %##...##.
		!byte %##...##.
		!byte %.#####..

		!byte %#######.
		!byte %##...##.
		!byte %....##..
		!byte %....##..
		!byte %...##...
		!byte %...##...
		!byte %..##....
		!byte %..##....

		!byte %.#####..
		!byte %##...##.
		!byte %##...##.
		!byte %.#####..
		!byte %##...##.
		!byte %##...##.
		!byte %##...##.
		!byte %.#####..

		!byte %.#####..
		!byte %##...##.
		!byte %##...##.
		!byte %##...##.
		!byte %.######.
		!byte %.....##.
		!byte %##...##.
		!byte %.#####..

		!if 1 {
		!byte %..###...
		!byte %.##.##..
		!byte %.#...#..
		!byte %##...##.
		!byte %#######.
		!byte %##...##.
		!byte %##...##.
		!byte %##...##.

		!byte %######..
		!byte %##....#.
		!byte %##....#.
		!byte %######..
		!byte %##....#.
		!byte %##....#.
		!byte %##....#.
		!byte %######..

		!byte %.#####..
		!byte %##....#.
		!byte %##......
		!byte %##......
		!byte %##......
		!byte %##......
		!byte %##....#.
		!byte %.#####..

		!byte %######..
		!byte %##....#.
		!byte %##....#.
		!byte %##....#.
		!byte %##....#.
		!byte %##....#.
		!byte %##....#.
		!byte %######..

		!byte %#######.
		!byte %##......
		!byte %##......
		!byte %######..
		!byte %##......
		!byte %##......
		!byte %##......
		!byte %#######.

		!byte %#######.
		!byte %##......
		!byte %##......
		!byte %######..
		!byte %##......
		!byte %##......
		!byte %##......
		!byte %##......
		}

statusbar_heart	!byte %.##.##..
		!byte %####.##.
		!byte %#######.
		!byte %#######.
		!byte %.#####..
		!byte %.#####..
		!byte %..###...
		!byte %...#....